Index: /trunk/XTIDE_Universal_BIOS/Src/Boot/BootMenuPrintCfg.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Src/Boot/BootMenuPrintCfg.asm	(revision 87)
+++ /trunk/XTIDE_Universal_BIOS/Src/Boot/BootMenuPrintCfg.asm	(revision 88)
@@ -1,7 +1,3 @@
-; File name		:	BootMenuPrintCfg.asm
-; Project name	:	IDE BIOS
-; Created date	:	28.3.2010
-; Last update	:	9.4.2010
-; Author		:	Tomi Tilli
+; Project name	:	XTIDE Universal BIOS
 ; Description	:	Functions for printing drive configuration
 ;					information on Boot Menu.
@@ -20,5 +16,5 @@
 ;		Nothing
 ;	Corrupts registers:
-;		AX, BX, CX, DX, SI, ES
+;		AX, BX, CX, DX, SI, DI, ES
 ;--------------------------------------------------------------------
 ALIGN JUMP_ALIGN
@@ -27,5 +23,5 @@
 	call	BootMenuPrintCfg_GetPointers
 	call	BootMenuPrintCfg_PushAndFormatCfgString
-	jmp		BootMenuPrint_ClearOneInfoLine
+	jmp		BootMenuPrint_Newline
 
 
@@ -39,11 +35,11 @@
 ;		Nothing
 ;	Corrupts registers:
-;		AX, BX, DX
+;		AX, SI, DI
 ;--------------------------------------------------------------------
 ALIGN JUMP_ALIGN
 BootMenuPrintCfg_HeaderAndChangeLine:
 	mov		si, g_szCfgHeader
-	call	PrintString_FromCS
-	jmp		BootMenuPrint_ClearOneInfoLine
+	call	PrintNullTerminatedStringFromCSSIandSetCF
+	jmp		BootMenuPrint_Newline
 
 
@@ -83,12 +79,42 @@
 ;		Nothing
 ;	Corrupts registers:
-;		AX, CX, DX, SI
+;		AX, DX, SI, DI
 ;--------------------------------------------------------------------
 ALIGN JUMP_ALIGN
 BootMenuPrintCfg_PushAndFormatCfgString:
+	push	bp
+
+	mov		bp, sp
 	; Fall to first push below
 
 ;--------------------------------------------------------------------
-; BootMenuPrintCfg_PushResetStatus
+; PushAddressingMode
+;	Parameters:
+;		DS:DI:	Ptr to DPT
+;		ES:BX:	Ptr to BOOTNFO
+;		CS:SI:	Ptr to IDEVARS
+;	Returns:
+;		Nothing (jumps to next push below)
+;	Corrupts registers:
+;		AX, DX
+;--------------------------------------------------------------------
+PushAddressingMode:
+	mov		dx, bx				; Backup BX to DX
+	mov		bx, MASK_DPT_ADDR	; Load addressing mode mask
+	and		bl, [di+DPT.bFlags]	; Addressing mode now in BX
+	push	WORD [cs:bx+.rgszAddressingModeString]
+	mov		bx, dx
+	jmp		SHORT .NextPush
+ALIGN WORD_ALIGN
+.rgszAddressingModeString:
+	dw		g_szLCHS
+	dw		g_szPCHS
+	dw		g_szLBA28
+	dw		g_szLBA48
+ALIGN JUMP_ALIGN
+.NextPush:
+
+;--------------------------------------------------------------------
+; PushBlockMode
 ;	Parameters:
 ;		DS:DI:	Ptr to DPT
@@ -100,59 +126,26 @@
 ;		AX
 ;--------------------------------------------------------------------
-BootMenuPrintCfg_PushResetStatus:
-	eMOVZX	ax, BYTE [di+DPT.bReset]
+PushBlockMode:
+	eMOVZX	ax, BYTE [di+DPT.bSetBlock]
 	push	ax
 
 ;--------------------------------------------------------------------
-; BootMenuPrintCfg_PushIRQ
-;	Parameters:
-;		DS:DI:	Ptr to DPT
-;		ES:BX:	Ptr to BOOTNFO
-;		CS:SI:	Ptr to IDEVARS
-;	Returns:
-;		Nothing (falls to next push below)
+; PushBusType
+;	Parameters:
+;		DS:DI:	Ptr to DPT
+;		ES:BX:	Ptr to BOOTNFO
+;		CS:SI:	Ptr to IDEVARS
+;	Returns:
+;		Nothing (jumps to next push below)
 ;	Corrupts registers:
 ;		AX, DX
 ;--------------------------------------------------------------------
-BootMenuPrintCfg_PushIRQ:
-	mov		dl, ' '						; Load space to DL
-	mov		al, [cs:si+IDEVARS.bIRQ]
-	test	al, al						; Interrupts disabled?
-	jz		SHORT .PushIrqDisabled
-	add		al, '0'						; Digit to ASCII
-	cmp		al, '9'						; Only one digit needed?
-	jbe		SHORT .PushCharacters
-
-	; Two digits needed
-	sub		al, 10						; Limit to single digit ASCII
-	mov		dl, '1'						; Load '1 to DX
-	jmp		SHORT .PushCharacters
-ALIGN JUMP_ALIGN
-.PushIrqDisabled:
-	mov		al, '-'						; Load line to AL
-	xchg	ax, dx						; Space to AL, line to DL
-ALIGN JUMP_ALIGN
-.PushCharacters:
-	push	ax
-	push	dx
-
-;--------------------------------------------------------------------
-; BootMenuPrintCfg_PushBusType
-;	Parameters:
-;		DS:DI:	Ptr to DPT
-;		ES:BX:	Ptr to BOOTNFO
-;		CS:SI:	Ptr to IDEVARS
-;	Returns:
-;		Nothing (jumps to next push below)
-;	Corrupts registers:
-;		AX, DX
-;--------------------------------------------------------------------
-BootMenuPrintCfg_PushBusType:
+PushBusType:
 	xchg	ax, bx		; Store BX to AX
 	eMOVZX	bx, BYTE [cs:si+IDEVARS.bBusType]
 	mov		bx, [cs:bx+.rgwBusTypeValues]	; Char to BL, Int to BH	
 	eMOVZX	dx, bh
+	push	bx			; Push character
 	push	dx			; Push 8, 16 or 32
-	push	bx			; Push character
 	xchg	bx, ax		; Restore BX
 	jmp		SHORT .NextPush
@@ -167,5 +160,5 @@
 
 ;--------------------------------------------------------------------
-; BootMenuPrintCfg_PushBlockMode
+; PushIRQ
 ;	Parameters:
 ;		DS:DI:	Ptr to DPT
@@ -175,38 +168,44 @@
 ;		Nothing (falls to next push below)
 ;	Corrupts registers:
+;		AX, DX
+;--------------------------------------------------------------------
+PushIRQ:
+	mov		dl, ' '						; Load space to DL
+	mov		al, [cs:si+IDEVARS.bIRQ]
+	test	al, al						; Interrupts disabled?
+	jz		SHORT .PushIrqDisabled
+	add		al, '0'						; Digit to ASCII
+	cmp		al, '9'						; Only one digit needed?
+	jbe		SHORT .PushCharacters
+
+	; Two digits needed
+	sub		al, 10						; Limit to single digit ASCII
+	mov		dl, '1'						; Load '1 to DX
+	jmp		SHORT .PushCharacters
+ALIGN JUMP_ALIGN
+.PushIrqDisabled:
+	mov		al, '-'						; Load line to AL
+	xchg	ax, dx						; Space to AL, line to DL
+ALIGN JUMP_ALIGN
+.PushCharacters:
+	push	dx
+	push	ax
+
+;--------------------------------------------------------------------
+; PushResetStatus
+;	Parameters:
+;		DS:DI:	Ptr to DPT
+;		ES:BX:	Ptr to BOOTNFO
+;		CS:SI:	Ptr to IDEVARS
+;	Returns:
+;		Nothing (falls to next push below)
+;	Corrupts registers:
 ;		AX
 ;--------------------------------------------------------------------
-BootMenuPrintCfg_PushBlockMode:
-	eMOVZX	ax, BYTE [di+DPT.bSetBlock]
+PushResetStatus:
+	eMOVZX	ax, BYTE [di+DPT.bReset]
 	push	ax
 
 ;--------------------------------------------------------------------
-; BootMenuPrintCfg_PushAddressingMode
-;	Parameters:
-;		DS:DI:	Ptr to DPT
-;		ES:BX:	Ptr to BOOTNFO
-;		CS:SI:	Ptr to IDEVARS
-;	Returns:
-;		Nothing (jumps to next push below)
-;	Corrupts registers:
-;		AX, DX
-;--------------------------------------------------------------------
-BootMenuPrintCfg_PushAddressingMode:
-	mov		dx, bx				; Backup BX to DX
-	mov		bx, MASK_DPT_ADDR	; Load addressing mode mask
-	and		bl, [di+DPT.bFlags]	; Addressing mode now in BX
-	push	WORD [cs:bx+.rgszAddressingModeString]
-	mov		bx, dx
-	jmp		SHORT .NextPush
-ALIGN WORD_ALIGN
-.rgszAddressingModeString:
-	dw	g_szLCHS
-	dw	g_szPCHS
-	dw	g_szLBA28
-	dw	g_szLBA48
-ALIGN JUMP_ALIGN
-.NextPush:
-
-;--------------------------------------------------------------------
 ; Prints formatted configuration string from parameters pushed to stack.
 ;
@@ -217,8 +216,7 @@
 ;		Nothing
 ;	Corrupts registers:
-;		AX, CX, DX, SI
+;		AX, SI, DI
 ;--------------------------------------------------------------------
 BootMenuPrintCfg_ValuesFromStack:
 	mov		si, g_szCfgFormat
-	mov		dh, 14						; 14 bytes pushed to stack
-	jmp		PrintString_JumpToFormat
+	jmp		PrintNullTerminatedStringFromCSSIandSetCF
Index: /trunk/XTIDE_Universal_BIOS/Src/Boot/BootPrint.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Src/Boot/BootPrint.asm	(revision 87)
+++ /trunk/XTIDE_Universal_BIOS/Src/Boot/BootPrint.asm	(revision 88)
@@ -1,3 +1,3 @@
-; Project name	:	IDE BIOS
+; Project name	:	XTIDE Universal BIOS
 ; Description	:	Functions for printing boot related strings.
 
@@ -6,6 +6,4 @@
 
 ;--------------------------------------------------------------------
-; Prints trying to boot string.
-;
 ; BootPrint_TryToBootFromDL
 ;	Parameters:
@@ -15,36 +13,26 @@
 ;		Nothing
 ;	Corrupts registers:
-;		AX, CX, SI, DI
+;		AX, SI
 ;--------------------------------------------------------------------
 ALIGN JUMP_ALIGN
 BootPrint_TryToBootFromDL:
-	push	dx
-	ePUSH_T	ax, BootPrint_PopDxAndReturn	; Return address
+	push	bp
+	mov		bp, sp
 
-	xor		dh, dh				; Translated drive number to DX
-	push	dx					; Push translated drive number
+	mov		ax, g_szHardDrv
+	test	dl, 80h
+	eCMOVZ	ax, g_szFloppyDrv
+	push	ax					; "Hard Drive" or "Floppy Drive"
+
 	call	DriveXlate_ToOrBack
 	push	dx					; Push untranslated drive number
-
-	mov		ax, g_szFloppyDrv	; Assume "Floppy Drive"
-	test	dl, 80h				; Hard Disk?
-	jz		SHORT .PushHardOrFloppy
-	add		ax, BYTE g_szHardDrv - g_szFloppyDrv
-.PushHardOrFloppy:
-	push	ax
+	call	DriveXlate_ToOrBack
+	push	dx					; Push translated drive number
 
 	mov		si, g_szTryToBoot
-	mov		dh, 6				; 6 bytes pushed to stack
-	jmp		PrintString_JumpToFormat
-
-ALIGN JUMP_ALIGN
-BootPrint_PopDxAndReturn:
-	pop		dx
-	ret
+	jmp		BootMenuPrint_FormatCSSIfromParamsInSSBP
 
 
 ;--------------------------------------------------------------------
-; Prints message that valid boot sector has been found.
-;
 ; BootPrint_BootSectorLoaded
 ;	Parameters:
@@ -53,18 +41,15 @@
 ;		Nothing
 ;	Corrupts registers:
-;		AX, CX, SI
+;		AX, SI
 ;--------------------------------------------------------------------
 ALIGN JUMP_ALIGN
 BootPrint_BootSectorLoaded:
-	push	dx
-	ePUSH_T	ax, BootPrint_PopDxAndReturn	; Return address
-
+	push	bp
+	mov		bp, sp
+	ePUSH_T	ax, g_szBootSector
 	ePUSH_T	ax, g_szFound
-	jmp		SHORT BootPrint_MsgCodeShared
-
+	jmp		SHORT PrintBootSectorResult
 
 ;--------------------------------------------------------------------
-; Prints message that first sector is not boot sector.
-;
 ; BootPrint_FirstSectorNotBootable
 ;	Parameters:
@@ -73,19 +58,18 @@
 ;		Nothing
 ;	Corrupts registers:
-;		AX, CX, DX, SI
+;		AX, SI
 ;--------------------------------------------------------------------
 ALIGN JUMP_ALIGN
 BootPrint_FirstSectorNotBootable:
+	push	bp
+	mov		bp, sp
+	ePUSH_T	ax, g_szBootSector
 	ePUSH_T	ax, g_szNotFound
-BootPrint_MsgCodeShared:
-	ePUSH_T	ax, g_szBootSector
+PrintBootSectorResult:
 	mov		si, g_szSectRead
-	mov		dh, 4				; 4 bytes pushed to stack
-	jmp		PrintString_JumpToFormat
+	jmp		BootMenuPrint_FormatCSSIfromParamsInSSBP
 
 
 ;--------------------------------------------------------------------
-; Prints error code for failed first sector read attempt.
-;
 ; BootPrint_FailedToLoadFirstSector
 ;	Parameters:
@@ -94,11 +78,12 @@
 ;		Nothing
 ;	Corrupts registers:
-;		AX, CX, DX, SI
+;		AX, CX, SI
 ;--------------------------------------------------------------------
 ALIGN JUMP_ALIGN
 BootPrint_FailedToLoadFirstSector:
+	push	bp
+	mov		bp, sp
 	eMOVZX	cx, ah				; Error code to CX
 	push	cx					; Push INT 13h error code
 	mov		si, g_szReadError
-	mov		dh, 2				; 2 bytes pushed to stack
-	jmp		PrintString_JumpToFormat
+	jmp		BootMenuPrint_FormatCSSIfromParamsInSSBP
Index: /trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AH25h_HDrvID.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AH25h_HDrvID.asm	(revision 87)
+++ /trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AH25h_HDrvID.asm	(revision 88)
@@ -1,7 +1,3 @@
-; File name		:	AH25h_HDrvID.asm
-; Project name	:	IDE BIOS
-; Created date	:	24.10.2009
-; Last update	:	14.4.2010
-; Author		:	Tomi Tilli
+; Project name	:	XTIDE Universal BIOS
 ; Description	:	Int 13h function AH=25h, Get Drive Information.
 
@@ -91,5 +87,4 @@
 	mov		al, HCMD_ID_DEV				; Load Identify Device command to AL
 	out		dx, al						; Output command
-	call	SoftDelay_BeforePollingStatusRegister
 	call	HStatus_WaitDrqDefTime		; Wait until ready to transfer (no IRQ!)
 	jc		SHORT .Return				; Return if error
Index: /trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AHDh_HReset.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AHDh_HReset.asm	(revision 87)
+++ /trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/AHDh_HReset.asm	(revision 88)
@@ -1,8 +1,3 @@
-; File name		:	AHDh_HReset.asm
-; Project name	:	IDE BIOS
-; Created date	:	9.12.2007
-; Last update	:	14.1.2011
-; Author		:	Tomi Tilli,
-;				:	Krister Nordvall (optimizations)
+; Project name	:	XTIDE Universal BIOS
 ; Description	:	Int 13h function AH=Dh, Reset Hard Disk (Alternate reset).
 
@@ -94,12 +89,12 @@
 	or		al, FLG_IDE_CTRL_SRST		; Set Reset bit
 	call	HDrvSel_OutputDeviceControlByte
-	mov		cx, 5						; Delay at least 5us
-	call	SoftDelay_us
+	mov		ax, 5						; Delay at least 5us
+	call	Delay_MicrosecondsFromAX
 
 	; HSR1: Clear_wait
-	and		al, ~FLG_IDE_CTRL_SRST		; Clear Reset bit
+	mov		al, [di+DPT.bDrvCtrl]		; Load value for ACR
 	out		dx, al						; End Reset
-	mov		cx, 2000					; Delay at least 2ms
-	call	SoftDelay_us
+	mov		ax, 2000					; Delay at least 2ms
+	call	Delay_MicrosecondsFromAX
 
 	; HSR2: Check_status
Index: /trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/Common/HCapacity.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/Common/HCapacity.asm	(revision 87)
+++ /trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/Common/HCapacity.asm	(revision 88)
@@ -1,7 +1,3 @@
-; File name		:	HCapacity.asm
-; Project name	:	IDE BIOS
-; Created date	:	16.3.2010
-; Last update	:	3.8.2010
-; Author		:	Tomi Tilli
+; Project name	:	XTIDE Universal BIOS
 ; Description	:	Functions for hard disk capacity calculations.
 
@@ -47,121 +43,2 @@
 	xor		bx, bx			; Zero BX for 48-bit sector count
 	ret
-
-
-;--------------------------------------------------------------------
-; Converts sector count to hard disk size.
-;
-; HCapacity_ConvertSectorCountToSize:
-;	Parameters:
-;		BX:DX:AX:	Total sector count
-;	Returns:
-;		AX:			Size in magnitude
-;		SI:			Tenths
-;		CX:			Magnitude character:
-;						'k' = *1024   B = kiB
-;						'M' = *1024 kiB = MiB
-;						'G' = *1024 MiB = GiB
-;						'T' = *1024 GiB = TiB
-;						'P' = *1024 TiB = PiB
-;	Corrupts registers:
-;		BX, DX
-;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
-HCapacity_ConvertSectorCountToSize:
-	call	HCapacity_ConvertSectorCountToKiB
-	mov		cx, 1					; Magnitude is 1 for kiB
-ALIGN JUMP_ALIGN
-.MagnitudeLoop:
-	test	bx, bx					; Bits 32...47 in use?
-	jnz		SHORT .ShiftByMagnitude	;  If so, jump to shift
-	test	dx, dx					; Bits 16...31 in use?
-	jnz		SHORT .ShiftByMagnitude	;  If so, jump to shift
-	cmp		ax, 10000				; 5 digits needed?
-	jb		SHORT .ShiftComplete	;  If less, all done
-ALIGN JUMP_ALIGN
-.ShiftByMagnitude:
-	call	HCapacity_ShiftForNextMagnitude
-	jmp		SHORT .MagnitudeLoop
-ALIGN JUMP_ALIGN
-.ShiftComplete:
-	mov		bx, cx					; Copy shift count to BX
-	mov		cl, [cs:bx+.rgbMagnitudeToChar]
-	jmp		SHORT HCapacity_ConvertSizeRemainderToTenths
-ALIGN WORD_ALIGN
-.rgbMagnitudeToChar:	db	" kMGTP"
-
-;--------------------------------------------------------------------
-; Converts 48-bit sector count to size in kiB.
-;
-; HCapacity_ConvertSectorCountToKiB:
-;	Parameters:
-;		BX:DX:AX:	Total sector count
-;	Returns:
-;		BX:DX:AX:	Total size in kiB
-;		CF:			Remainder from division
-;	Corrupts registers:
-;		Nothing
-;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
-HCapacity_ConvertSectorCountToKiB:
-HCapacity_DivideSizeByTwo:
-	shr		bx, 1					; Divide sector count by 2...
-	rcr		dx, 1					; ...to get disk size in...
-	rcr		ax, 1					; ...kiB
-	ret
-
-;--------------------------------------------------------------------
-; Divides size by 1024 and increments magnitude.
-;
-; HCapacity_ShiftForNextMagnitude:
-;	Parameters:
-;		BX:DX:AX:	Size in magnitude
-;		CX:			Magnitude (0=B, 1=kiB, 2=MiB...)
-;	Returns:
-;		BX:DX:AX:	Size in magnitude
-;		SI:			Remainder (0...1023)
-;		CX:			Magnitude (1=kiB, 2=MiB...)
-;	Corrupts registers:
-;		Nothing
-;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
-HCapacity_ShiftForNextMagnitude:
-	push	cx
-	xor		si, si					; Zero remainder
-	mov		cl, 10					; Divide by 1024
-ALIGN JUMP_ALIGN
-.ShiftLoop:
-	call	HCapacity_DivideSizeByTwo
-	rcr		si, 1					; Update remainder
-	loop	.ShiftLoop
-	eSHR_IM	si, 6					; Remainder to SI beginning
-	pop		cx
-	inc		cx						; Increment shift count
-	ret
-
-;--------------------------------------------------------------------
-; Converts remainder from HCapacity_ShiftForNextMagnitude to tenths.
-;
-; HCapacity_ConvertSizeRemainderToTenths:
-;	Parameters:
-;		BX:DX:AX:	Size in magnitude
-;		SI:			Remainder from last magnitude division (0...1023)
-;	Returns:
-;		BX:DX:AX:	Size in magnitude
-;		SI:			Tenths
-;	Corrupts registers:
-;		Nothing
-;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
-HCapacity_ConvertSizeRemainderToTenths:
-	push	dx
-	push	ax
-
-	mov		ax, 10
-	mul		si					; DX:AX = remainder * 10
-	eSHR_IM	ax, 10				; Divide AX by 1024
-	xchg	si, ax				; SI = tenths
-
-	pop		ax
-	pop		dx
-	ret
Index: /trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/Common/HCommand.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/Common/HCommand.asm	(revision 87)
+++ /trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/Common/HCommand.asm	(revision 88)
@@ -1,7 +1,3 @@
-; File name		:	HCommand.asm
-; Project name	:	IDE BIOS
-; Created date	:	28.3.2010
-; Last update	:	16.4.2010
-; Author		:	Tomi Tilli
+; Project name	:	XTIDE Universal BIOS
 ; Description	:	Functions for outputting IDE commands and parameters.
 
@@ -113,3 +109,3 @@
 	out		dx, al
 	mov		al, ah						; Restore sector count to AL
-	jmp		SoftDelay_BeforePollingStatusRegister
+	ret
Index: /trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/Common/HDrvSel.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/Common/HDrvSel.asm	(revision 87)
+++ /trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/Common/HDrvSel.asm	(revision 88)
@@ -1,7 +1,3 @@
-; File name		:	HDrvSel.asm
-; Project name	:	IDE BIOS
-; Created date	:	25.2.2010
-; Last update	:	13.4.2010
-; Author		:	Tomi Tilli
+; Project name	:	XTIDE Universal BIOS
 ; Description	:	Functions for selecting Master or Slave drive.
 
@@ -60,5 +56,4 @@
 
 	; Wait until drive is ready to accept commands
-	call	SoftDelay_BeforePollingStatusRegister
 	call	HStatus_WaitRdyDefTime
 	pop		cx
Index: /trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/Common/HStatus.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/Common/HStatus.asm	(revision 87)
+++ /trunk/XTIDE_Universal_BIOS/Src/Handlers/Int13h/Common/HStatus.asm	(revision 88)
@@ -1,7 +1,3 @@
-; File name		:	HStatus.asm
-; Project name	:	IDE BIOS
-; Created date	:	15.12.2009
-; Last update	:	23.8.2010
-; Author		:	Tomi Tilli
+; Project name	:	XTIDE Universal BIOS
 ; Description	:	IDE Status Register polling functions.
 
@@ -176,5 +172,5 @@
 ALIGN JUMP_ALIGN
 HStatus_PollBsyAndFlg:
-	call	SoftDelay_InitTimeout				; Initialize timeout counter
+	call	InitializeTimeoutWithTicksInCL		; Initialize timeout counter
 	in		al, dx								; Discard contents for first read
 												; (should read Alternate Status Register)
@@ -188,5 +184,5 @@
 ALIGN JUMP_ALIGN
 .UpdateTimeout:
-	call	SoftDelay_UpdTimeout				; Update timeout counter
+	call	SetCFifTimeout
 	jnc		SHORT .PollLoop						; Loop if time left (sets CF on timeout)
 	jmp		HError_ProcessTimeoutAfterPollingBSYandSomeOtherStatusBit
@@ -210,5 +206,5 @@
 ALIGN JUMP_ALIGN
 HStatus_PollBsy:
-	call	SoftDelay_InitTimeout				; Initialize timeout counter
+	call	InitializeTimeoutWithTicksInCL		; Initialize timeout counter
 	in		al, dx								; Discard contents for first read
 												; (should read Alternate Status Register)
@@ -218,7 +214,52 @@
 	test	al, FLG_IDE_ST_BSY					; Controller busy?
 	jz		SHORT GetErrorCodeFromPollingToAH	;  If not, jump to check errors
-	call	SoftDelay_UpdTimeout				; Update timeout counter
+	call	SetCFifTimeout						; Update timeout counter
 	jnc		SHORT .PollLoop						; Loop if time left (sets CF on timeout)
 ALIGN JUMP_ALIGN
 GetErrorCodeFromPollingToAH:
 	jmp		HError_ProcessErrorsAfterPollingBSY
+
+
+;--------------------------------------------------------------------
+; InitializeTimeoutWithTicksInCL
+;	Parameters:
+;		CL:		Timeout value in system timer ticks
+;		DS:		Segment to RAMVARS
+;	Returns:
+;		Nothing
+;	Corrupts registers:
+;		CX
+;--------------------------------------------------------------------
+ALIGN JUMP_ALIGN
+InitializeTimeoutWithTicksInCL:
+	push	bx
+	xchg	cx, ax
+
+	xor		ah, ah		; Timeout ticks now in AX
+	mov		bx, RAMVARS.wTimeoutCounter
+	call	TimerTicks_InitializeTimeoutFromAX
+
+	xchg	ax, cx		; Restore AX
+	pop		bx
+	ret
+
+;--------------------------------------------------------------------
+; SetCFifTimeout
+;	Parameters:
+;		DS:		Segment to RAMVARS
+;	Returns:
+;		Nothing
+;	Corrupts registers:
+;		CX
+;--------------------------------------------------------------------
+ALIGN JUMP_ALIGN
+SetCFifTimeout:
+	push	bx
+	xchg	cx, ax
+
+	mov		bx, RAMVARS.wTimeoutCounter
+	call	TimerTicks_GetTimeoutTicksLeftToAXfromDSBX
+
+	xchg	ax, cx		; Restore AX
+	pop		bx
+	ret
Index: /trunk/XTIDE_Universal_BIOS/Src/Handlers/Int18h.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Src/Handlers/Int18h.asm	(revision 87)
+++ /trunk/XTIDE_Universal_BIOS/Src/Handlers/Int18h.asm	(revision 88)
@@ -1,7 +1,3 @@
-; File name		:	Int18h.asm
-; Project name	:	IDE BIOS
-; Created date	:	6.1.2010
-; Last update	:	25.3.2010
-; Author		:	Tomi Tilli
+; Project name	:	XTIDE Universal BIOS
 ; Description	:	Int 18h BIOS functions (ROM boot and Boot error).
 
@@ -24,4 +20,4 @@
 Int18h_BootError:
 	mov		si, g_sz18hCallback
-	call	PrintString_FromCS		; No need to clean stack
+	call	PrintNullTerminatedStringFromCSSIandSetCF
 	jmp		Int19hMenu_Display		; Return to boot menu
Index: /trunk/XTIDE_Universal_BIOS/Src/Initialization/DetectPrint.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Src/Initialization/DetectPrint.asm	(revision 87)
+++ /trunk/XTIDE_Universal_BIOS/Src/Initialization/DetectPrint.asm	(revision 88)
@@ -1,3 +1,3 @@
-; Project name	:	IDE BIOS
+; Project name	:	XTIDE Universal BIOS
 ; Description	:	Functions for printing drive detection strings.
 
@@ -14,12 +14,15 @@
 ;		Nothing
 ;	Corrupts registers:
-;		AX, CX, DX, SI
+;		AX, SI
 ;--------------------------------------------------------------------
 ALIGN JUMP_ALIGN
 DetectPrint_RomFoundAtSegment:
-	push	cs
-	ePUSH_T	ax, ROMVARS.szTitle
+	push	bp
+
 	mov		si, g_szRomAt
-	jmp		SHORT DetectPrint_4BytesPushedToStack
+	mov		bp, sp
+	ePUSH_T	ax, ROMVARS.szTitle			; Bios title string
+	push	cs							; BIOS segment
+	jmp		BootMenuPrint_FormatCSSIfromParamsInSSBP
 
 
@@ -34,5 +37,5 @@
 ;		Nothing
 ;	Corrupts registers:
-;		AX, CX, DX, SI
+;		AX, SI
 ;--------------------------------------------------------------------
 ALIGN JUMP_ALIGN
@@ -50,19 +53,21 @@
 ; DetectPrint_StartingDriveDetect
 ;	Parameters:
-;		AX:		Offset to "Master" or "Slave" string
+;		CS:AX:	Ptr to "Master" or "Slave" string
 ;		CS:BP:	Ptr to IDEVARS
 ;	Returns:
 ;		Nothing
 ;	Corrupts registers:
-;		AX, CX, DX, SI
+;		AX, SI
 ;--------------------------------------------------------------------
 ALIGN JUMP_ALIGN
 DetectPrint_StartingDriveDetect:
-	push	WORD [cs:bp+IDEVARS.wPort]
-	push	ax
+	push	bp
+
+	mov		si, [cs:bp+IDEVARS.wPort]
+	mov		bp, sp
+	push	ax							; Push "Master" or "Slave"
+	push	si							; Push port number
 	mov		si, g_szDetect
-DetectPrint_4BytesPushedToStack:
-	mov		dh, 4						; 4 bytes pushed to stack
-	jmp		PrintString_JumpToFormat
+	jmp		BootMenuPrint_FormatCSSIfromParamsInSSBP
 
 
@@ -79,14 +84,25 @@
 ;		Nothing
 ;	Corrupts registers:
-;		AX, DX, SI
+;		AX, SI
 ;--------------------------------------------------------------------
 ALIGN JUMP_ALIGN
 DetectPrint_DriveNameOrNotFound:
+	push	di
 	jc		SHORT .PrintDriveNotFound
+	push	bx
+
 	lea		si, [bx+BOOTNFO.szDrvName]
-	call	PrintString_FromES
-	jmp		Print_Newline
+	mov		bx, es
+	CALL_DISPLAY_LIBRARY PrintNullTerminatedStringFromBXSI
+	CALL_DISPLAY_LIBRARY PrintNewlineCharacters
+
+	pop		bx
+	pop		di
+	ret
+
 ALIGN JUMP_ALIGN
 .PrintDriveNotFound:
 	mov		si, g_szNotFound
-	jmp		PrintString_FromCS
+	call	PrintNullTerminatedStringFromCSSIandSetCF
+	pop		di
+	ret
Index: /trunk/XTIDE_Universal_BIOS/Src/Main.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Src/Main.asm	(revision 87)
+++ /trunk/XTIDE_Universal_BIOS/Src/Main.asm	(revision 88)
@@ -13,6 +13,6 @@
 
 ; Included .inc files
-%include "emulate.inc"			; Must be included first!
-%include "macros.inc"			; For generic macros
+%include "AssemblyLibrary.inc"	; Assembly Library. Must be included first!
+%include "macros.inc"			; General purpose macros
 %include "BiosData.inc"			; For BIOS Data area equates
 %include "Interrupts.inc"		; For interrupt equates
@@ -38,16 +38,16 @@
 	at	ROMVARS.bRomSize,	db	CNT_ROM_BLOCKS	; ROM size in 512B blocks
 	at	ROMVARS.rgbJump, 	jmp	Initialize_FromMainBiosRomSearch
-	at	ROMVARS.rgbDate,	db	"11/28/10"		; Build data (mm/dd/yy)
-	at	ROMVARS.rgbSign,	db	"XTIDE110"		; Signature for flash program
+	at	ROMVARS.rgbDate,	db	"01/27/11"		; Build data (mm/dd/yy)
+	at	ROMVARS.rgbSign,	db	"XTIDE120"		; Signature for flash program
 	at	ROMVARS.szTitle
 		db	"-=XTIDE Universal BIOS"
 %ifdef USE_AT
-		db	" (AT)=-",STOP
+		db	" (AT)=-",NULL
 %elifdef USE_186
-		db	" (XT+)=-",STOP
+		db	" (XT+)=-",NULL
 %else
-		db	" (XT)=-",STOP
+		db	" (XT)=-",NULL
 %endif
-	at	ROMVARS.szVersion,	db	"v1.1.5 (11/28/10)",STOP
+	at	ROMVARS.szVersion,	db	"v1.2.0_wip (01/27/11)",NULL
 
 ;---------------------------;
@@ -58,5 +58,4 @@
 	at	ROMVARS.bIdeCnt,		db	3						; Number of supported controllers
 	at	ROMVARS.bBootDrv,		db	80h						; Boot Menu default drive
-	at	ROMVARS.bBootMnuH,		db	20						; Boot Menu maximum height
 	at	ROMVARS.bBootDelay,		db	30						; Boot Menu selection delay (secs)
 	at	ROMVARS.bBootLdrType,	db	BOOTLOADER_TYPE_MENU	; Boot loader type
@@ -91,5 +90,4 @@
 	at	ROMVARS.bIdeCnt,		db	1						; Number of supported controllers
 	at	ROMVARS.bBootDrv,		db	80h						; Boot Menu default drive
-	at	ROMVARS.bBootMnuH,		db	20						; Boot Menu maximum height
 	at	ROMVARS.bBootDelay,		db	30						; Boot Menu selection delay (secs)
 	at	ROMVARS.bBootLdrType,	db	BOOTLOADER_TYPE_MENU	; Boot loader type
@@ -108,12 +106,6 @@
 
 ; Include .asm files (static data and libraries)
+%include "AssemblyLibrary.asm"
 %include "Strings.asm"			; For BIOS message strings
-%include "math.asm"				; For Math library
-%include "string.asm"			; For String library
-%include "print.asm"			; For Print library
-%include "keys.asm"				; For keyboard library (required by menu library)
-%include "menu.asm"				; For menu library
-%include "PrintString.asm"		; Customized printing for this BIOS
-%include "SoftDelay.asm"		; For software delay loops
 
 ; Include .asm files (Initialization and drive detection)
@@ -178,3 +170,3 @@
 
 ; Fill with zeroes until size is what we want
-times (CNT_ROM_BLOCKS*512)-($-$$) db 0
+;times (CNT_ROM_BLOCKS*512)-($-$$) db 0
Index: /trunk/XTIDE_Universal_BIOS/Src/Strings.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Src/Strings.asm	(revision 87)
+++ /trunk/XTIDE_Universal_BIOS/Src/Strings.asm	(revision 88)
@@ -1,7 +1,3 @@
-; File name		:	Strings.asm
-; Project name	:	IDE BIOS
-; Created date	:	4.12.2007
-; Last update	:	9.4.2010
-; Author		:	Tomi Tilli
+; Project name	:	XTIDE Universal BIOS
 ; Description	:	Strings and equates for BIOS messages.
 
@@ -10,44 +6,41 @@
 
 ; POST drive detection strings
-g_szRomAt:		db	"%s @ %x",CR,LF,STOP
-g_szMaster:		db	"Master",STOP
-g_szSlave:		db	"Slave ",STOP
-g_szDetect:		db	"IDE %s at %x: ",STOP			; IDE Master at 1F0h:
-g_szNotFound:	db	"not found",CR,LF,STOP
+g_szRomAt:		db	"%s @ %x",CR,LF,NULL
+g_szMaster:		db	"Master",NULL
+g_szSlave:		db	"Slave ",NULL
+g_szDetect:		db	"IDE %s at %x: ",NULL			; IDE Master at 1F0h:
+g_szNotFound:	db	"not found",CR,LF,NULL
 
 ; Boot loader strings
-g_szFloppyDrv:	db	"Floppy Drive",STOP
-g_szHardDrv:	db	" Hard Drive ",STOP
-g_szTryToBoot:	db	"Booting from %s %x",175,"%x ... ",STOP
-g_szBootSector:	db	"Boot Sector",STOP
-g_szFound:		db	"found",STOP
-g_szSectRead:	db	"%s %s!",CR,LF,STOP
-g_szReadError:	db	"Error %x!",CR,LF,STOP
-g_sz18hCallback:db	"Boot menu callback via INT 18h",STOP
+g_szFloppyDrv:	db	"Floppy Drive",NULL
+g_szHardDrv:	db	" Hard Drive ",NULL
+g_szTryToBoot:	db	"Booting from %s %x",175,"%x ... ",NULL
+g_szBootSector:	db	"Boot Sector",NULL
+g_szFound:		db	"found",NULL
+g_szSectRead:	db	"%s %s!",CR,LF,NULL
+g_szReadError:	db	"Error %x!",CR,LF,NULL
+g_sz18hCallback:db	"Boot menu callback via INT 18h",NULL
 
 ; Boot menu bottom of screen strings
-g_szFDD:		db	"FDD",STOP
-g_szHDD:		db	"HDD",STOP
-g_szBottomScrn:	db	"%c to %c boots from %s with %s mappings",CR,LF,STOP
-
-; Boot Menu title strings
-g_szTitleLn3:	db	"Copyright 2009-2010 by Tomi Tilli",STOP
+g_szFDD:		db	"FDD",NULL
+g_szHDD:		db	"HDD",NULL
+g_szBottomScrn:	db	"%c to %c boots from %s with %s mappings",CR,LF,NULL
 
 ; Boot Menu menuitem strings
-g_szFDLetter:	db	"%s %c",STOP
-g_szforeignHD:	db	"Foreign Hard Disk",STOP
-g_szRomBoot:	db	"ROM Boot",STOP
+g_szFDLetter:	db	"%s %c",NULL
+g_szforeignHD:	db	"Foreign Hard Disk",NULL
+g_szRomBoot:	db	"ROM Boot",NULL
 
 ; Boot Menu information strings
-g_szCapacity:	db	"Capacity : ",STOP
-g_szSizeSingle:	db	"%s%u.%u %ciB",STOP
-g_szSizeDual:	db	"%s%u.%u %ciB / %u.%u %ciB",STOP
-g_szCfgHeader:	db	"Addr.", T_V, "Block", T_V, "Bus",   T_V, "IRQ",   T_V, "Reset", STOP
-g_szCfgFormat:	db	"%s"   , T_V, "%5u",   T_V, "%c%2u", T_V, " %c%c", T_V, "%5x",   STOP
-g_szLCHS:		db	"L-CHS",STOP
-g_szPCHS:		db	"P-CHS",STOP
-g_szLBA28:		db	"LBA28",STOP
-g_szLBA48:		db	"LBA48",STOP
-g_szFddUnknown:	db	"%sUnknown",STOP
-g_szFddSizeOr:	db	"%s5",172,22h," or 3",171,22h," DD",STOP
-g_szFddSize:	db	"%s%c%c",22h,", %u kiB",STOP	; 3½", 1440 kiB
+g_szCapacity:	db	"Capacity : ",NULL
+g_szSizeSingle:	db	"%s%u.%u %ciB",NULL
+g_szSizeDual:	db	"%s%u.%u %ciB / %u.%u %ciB",NULL
+g_szCfgHeader:	db	"Addr.",SINGLE_VERTICAL,"Block",SINGLE_VERTICAL,"Bus",  SINGLE_VERTICAL,"IRQ",  SINGLE_VERTICAL,"Reset",NULL
+g_szCfgFormat:	db	"%s"   ,SINGLE_VERTICAL,"%5u",  SINGLE_VERTICAL,"%c%2u",SINGLE_VERTICAL," %c%c",SINGLE_VERTICAL,"%5x",  NULL
+g_szLCHS:		db	"L-CHS",NULL
+g_szPCHS:		db	"P-CHS",NULL
+g_szLBA28:		db	"LBA28",NULL
+g_szLBA48:		db	"LBA48",NULL
+g_szFddUnknown:	db	"%sUnknown",NULL
+g_szFddSizeOr:	db	"%s5",172,22h," or 3",171,22h," DD",NULL
+g_szFddSize:	db	"%s%c%c",22h,", %u kiB",NULL	; 3½", 1440 kiB
Index: /trunk/XTIDE_Universal_BIOS/makefile
===================================================================
--- /trunk/XTIDE_Universal_BIOS/makefile	(revision 87)
+++ /trunk/XTIDE_Universal_BIOS/makefile	(revision 88)
@@ -41,6 +41,19 @@
 HEADERS += Src/Initialization/
 HEADERS += Src/Libraries/
-HEADERS += Src/Libraries/menu/
 HEADERS += Src/VariablesAndDPTs/
+
+# Subdirectories where library files are:
+LIBS = ../Assembly_Library/Inc/
+LIBS += ../Assembly_Library/Src/
+LIBS += ../Assembly_Library/Src/Display/
+LIBS += ../Assembly_Library/Src/File/
+LIBS += ../Assembly_Library/Src/Keyboard/
+LIBS += ../Assembly_Library/Src/Menu/
+LIBS += ../Assembly_Library/Src/Menu/Dialog/
+LIBS += ../Assembly_Library/Src/String/
+LIBS += ../Assembly_Library/Src/Time/
+LIBS += ../Assembly_Library/Src/Util/
+LIBS += ../XTIDE_Universal_BIOS/Inc/
+HEADERS += $(LIBS)
 
 
@@ -48,7 +61,7 @@
 # Assembler preprocessor defines.                               #
 #################################################################
-DEFINES =
-DEFINES_XT = 
-DEFINES_XTPLUS = USE_186
+DEFINES = INCLUDE_MENU_LIBRARY EXCLUDE_BIT_UTILS EXCLUDE_SORT_UTILS
+DEFINES_XT = ELIMINATE_CGA_SNOW
+DEFINES_XTPLUS = ELIMINATE_CGA_SNOW USE_186
 DEFINES_AT = USE_186 USE_286 USE_AT
 
